function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import React, { useEffect, useState } from 'react';
import { Form, Select, Drawer, Tooltip, Button } from 'antd';
import StyleConfigPropertyItem from './StyleConfigPropertyItem';
import { SPLITOR } from './registerMeta';
import Util from '../utils';
import $i18n from '../i18n';
var Option = Select.Option;
var createUuid = Util.createUuid;
var EditDrawer = function EditDrawer(_ref) {
  var type = _ref.type,
    itemData = _ref.itemData,
    visible = _ref.visible,
    nodeProperties = _ref.nodeProperties,
    edgeProperties = _ref.edgeProperties,
    nodeTypes = _ref.nodeTypes,
    edgeTypes = _ref.edgeTypes,
    container = _ref.container,
    saveItem = _ref.saveItem,
    onClose = _ref.onClose;
  var _a;
  var _Form$useForm = Form.useForm(),
    _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
    form = _Form$useForm2[0];
  var getFieldsValue = form.getFieldsValue,
    setFieldsValue = form.setFieldsValue,
    validateFields = form.validateFields,
    resetFields = form.resetFields;
  var _useState = useState(),
    _useState2 = _slicedToArray(_useState, 2),
    source = _useState2[0],
    setSource = _useState2[1];
  var _useState3 = useState(),
    _useState4 = _slicedToArray(_useState3, 2),
    target = _useState4[0],
    setTarget = _useState4[1];
  var _useState5 = useState(),
    _useState6 = _slicedToArray(_useState5, 2),
    selectedNodeType = _useState6[0],
    setSelectedNodeType = _useState6[1];
  var _useState7 = useState([]),
    _useState8 = _slicedToArray(_useState7, 2),
    relatedEdgeTypes = _useState8[0],
    setRelatedEdgeTypes = _useState8[1];
  var _useState9 = useState([]),
    _useState10 = _slicedToArray(_useState9, 2),
    addedProperties = _useState10[0],
    setAddedProperties = _useState10[1];
  var _useState11 = useState([]),
    _useState12 = _slicedToArray(_useState11, 2),
    properties = _useState12[0],
    setProperties = _useState12[1];
  var _useState13 = useState(),
    _useState14 = _slicedToArray(_useState13, 2),
    selectedEdgeType = _useState14[0],
    setSelectedEdgeType = _useState14[1];
  var onSelectNodeType = function onSelectNodeType(key, endType) {
    switch (endType) {
      case 'source':
        setSource(key);
        form.setFieldsValue(_defineProperty({}, "edge.edgeType", null));
        break;
      case 'target':
        setTarget(key);
        form.setFieldsValue(_defineProperty({}, "edge.edgeType", null));
        break;
      case 'node':
        {
          setSelectedNodeType(key);
          break;
        }
      default:
        break;
    }
    setAddedProperties([]);
  };
  var onSelectEdgeType = function onSelectEdgeType(edgeType) {
    setProperties(Array.from(edgeProperties[edgeType]));
    setSelectedEdgeType(edgeType);
  };
  var addPropertyItem = function addPropertyItem() {
    var propertyId = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;
    setAddedProperties(function (oldAddedProperties) {
      var previousAddedProperties = _toConsumableArray(oldAddedProperties);
      var color;
      previousAddedProperties.forEach(function (item) {
        if (item.color) {
          color = item.color;
        }
      });
      color = color === '#2E71D6' ? '#D97825' : '#2E71D6';
      var uniqueId = propertyId || createUuid();
      previousAddedProperties.push({
        id: "".concat(uniqueId).concat(SPLITOR).concat(type).concat(SPLITOR).concat(itemData.id),
        color: color,
        visible: true
      });
      return previousAddedProperties;
    });
  };
  var deleteProperty = function deleteProperty(pid) {
    var previousAddedProperties = _toConsumableArray(addedProperties);
    previousAddedProperties.forEach(function (property, i) {
      if (property.id === pid) {
        previousAddedProperties.splice(i, 1);
      }
    });
    var values = getFieldsValue();
    delete values["".concat(pid).concat(SPLITOR, "name")];
    delete values["".concat(pid).concat(SPLITOR, "value")];
    delete values["".concat(pid).concat(SPLITOR, "operator")];
    delete values["".concat(pid).concat(SPLITOR, "color")];
    setFieldsValue(Object.assign({}, values));
    setAddedProperties(previousAddedProperties);
  };
  var cancelEdit = function cancelEdit() {
    setAddedProperties([]);
    setSource(undefined);
    setTarget(undefined);
    setSelectedNodeType(undefined);
    setSelectedEdgeType(undefined);
    onClose();
  };
  var confirmEdit = function confirmEdit() {
    var values = getFieldsValue();
    validateFields().then(function (_) {
      var item = {
        id: itemData.id,
        data: {},
        rules: []
      };
      var rulesMap = {};
      if (values) {
        Object.keys(values).forEach(function (key) {
          var value = key === 'node.nodeType' ? selectedNodeType : values[key];
          if (value === undefined) return;
          if (type === 'node' && key === 'node.nodeType') {
            item.nodeType = value;
          } else if (type === 'edge' && key === 'edge.edgeType') {
            item.edgeType = value.split(SPLITOR)[1];
          } else if (type === 'edge') {
            if (key === 'edge.sourceNodeType') {
              item.sourceNodeType = value;
            } else if (key === 'edge.targetNodeType') {
              item.targetNodeType = value;
            }
          }
          if (key.split(SPLITOR).length === 4) {
            var _key$split = key.split(SPLITOR),
              _key$split2 = _slicedToArray(_key$split, 4),
              ruleId = _key$split2[0],
              _type = _key$split2[1],
              dataId = _key$split2[2],
              field = _key$split2[3];
            if (!rulesMap[ruleId]) rulesMap[ruleId] = {};
            switch (field) {
              case 'name':
                rulesMap[ruleId].name = value;
                rulesMap[ruleId].key = value;
                break;
              case 'operator':
                rulesMap[ruleId].rule = value;
                break;
              case 'value':
                rulesMap[ruleId].value = value;
                break;
              default:
                break;
            }
          }
        });
      }
      Object.values(rulesMap).forEach(function (value) {
        item.rules.push(value);
      });
      saveItem === null || saveItem === void 0 ? void 0 : saveItem(type, item);
    });
    // 清空面板内容
    cancelEdit();
  };
  var init = function init() {
    setSelectedEdgeType(type === 'edge' ? itemData === null || itemData === void 0 ? void 0 : itemData.edgeType : undefined);
    setSelectedNodeType(type === 'node' ? itemData === null || itemData === void 0 ? void 0 : itemData.nodeType : undefined);
    resetFields();
  };
  useEffect(function () {
    setSelectedEdgeType(undefined);
    var sourceType = source || (itemData === null || itemData === void 0 ? void 0 : itemData.sourceNodeType);
    var targetType = target || (itemData === null || itemData === void 0 ? void 0 : itemData.targetNodeType);
    if (sourceType && targetType) {
      // 设置边选择器选项
      var relatedETypes = [];
      edgeTypes.forEach(function (edgeType) {
        var sourceNodeType = edgeType.sourceNodeType,
          targetNodeType = edgeType.targetNodeType;
        // 筛选出与选定的节点类型相关的边类型
        if (sourceNodeType === sourceType && targetNodeType === targetType) {
          relatedETypes.push(edgeType);
        }
      });
      setRelatedEdgeTypes(relatedETypes);
    } else {
      setRelatedEdgeTypes([]);
    }
  }, [source, target, itemData === null || itemData === void 0 ? void 0 : itemData.id]);
  useEffect(function () {
    var _a;
    if (itemData === null || itemData === void 0 ? void 0 : itemData.sourceNodeType) {
      setSource(itemData === null || itemData === void 0 ? void 0 : itemData.sourceNodeType);
    }
    if (itemData === null || itemData === void 0 ? void 0 : itemData.targetNodeType) {
      setTarget(itemData === null || itemData === void 0 ? void 0 : itemData.targetNodeType);
    }
    setAddedProperties([]);
    // rules 回填
    if (itemData === null || itemData === void 0 ? void 0 : itemData.rules) {
      (_a = itemData === null || itemData === void 0 ? void 0 : itemData.rules) === null || _a === void 0 ? void 0 : _a.forEach(function (rule) {
        var propertyId = createUuid();
        var pid = "".concat(propertyId).concat(SPLITOR).concat(type).concat(SPLITOR).concat(itemData.id);
        setTimeout(function () {
          setFieldsValue(_defineProperty(_defineProperty(_defineProperty({}, "".concat(pid).concat(SPLITOR, "name"), rule.name), "".concat(pid).concat(SPLITOR, "operator"), rule.rule), "".concat(pid).concat(SPLITOR, "value"), rule.value));
        }, 0);
        addPropertyItem(propertyId);
      });
    }
  }, [itemData === null || itemData === void 0 ? void 0 : itemData.data, itemData === null || itemData === void 0 ? void 0 : itemData.rules]);
  // 元素变化，清空面板内容
  useEffect(function () {
    init();
  }, [itemData === null || itemData === void 0 ? void 0 : itemData.id]);
  // 选中的节点类型发生变化，则 properties 变化
  useEffect(function () {
    if (!selectedNodeType) {
      return;
    }
    setProperties(Array.from(nodeProperties[selectedNodeType]));
  }, [selectedNodeType]);
  var edgeSelectorEnabled = relatedEdgeTypes && (relatedEdgeTypes === null || relatedEdgeTypes === void 0 ? void 0 : relatedEdgeTypes.length);
  var edgeSelector = /*#__PURE__*/React.createElement(Form.Item, {
    rules: [{
      required: true,
      message: $i18n.get({
        id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.CannotBeEmpty',
        dm: '不可为空'
      })
    }],
    name: "edge.edgeType",
    key: "edge.edgeType"
  }, /*#__PURE__*/React.createElement(Select, {
    showSearch: true,
    placeholder: $i18n.get({
      id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.PleaseSelect',
      dm: '请选择'
    }),
    style: {
      width: 316,
      marginTop: 8
    },
    onSelect: onSelectEdgeType,
    dropdownMatchSelectWidth: false,
    disabled: !edgeSelectorEnabled,
    defaultValue: (itemData === null || itemData === void 0 ? void 0 : itemData.edgeType) ? "".concat(itemData === null || itemData === void 0 ? void 0 : itemData.sourceNodeType, "_").concat(itemData === null || itemData === void 0 ? void 0 : itemData.edgeType, "_").concat(itemData === null || itemData === void 0 ? void 0 : itemData.targetNodeType) : undefined
  }, relatedEdgeTypes === null || relatedEdgeTypes === void 0 ? void 0 : relatedEdgeTypes.map(function (edgeType) {
    return /*#__PURE__*/React.createElement(Option, {
      value: edgeType.key,
      key: edgeType.key
    }, edgeType.content);
  })));
  var propertySelectorEnabled = type === 'edge' ? (relatedEdgeTypes === null || relatedEdgeTypes === void 0 ? void 0 : relatedEdgeTypes.length) && (selectedEdgeType || (itemData === null || itemData === void 0 ? void 0 : itemData.edgeType)) : !!selectedNodeType || (itemData === null || itemData === void 0 ? void 0 : itemData.edgeType);
  var propertySelector = /*#__PURE__*/React.createElement("div", null, addedProperties === null || addedProperties === void 0 ? void 0 : addedProperties.map(function (property) {
    return /*#__PURE__*/React.createElement(StyleConfigPropertyItem, {
      pid: property.id,
      properties: properties,
      deleteItem: deleteProperty,
      color: property === null || property === void 0 ? void 0 : property.color,
      visible: property === null || property === void 0 ? void 0 : property.visible,
      form: form,
      disabled: !propertySelectorEnabled,
      configColor: false
    });
  }), ((_a = addedProperties === null || addedProperties === void 0 ? void 0 : addedProperties.filter(function (property) {
    return property.visible;
  })) === null || _a === void 0 ? void 0 : _a.length) < 2 && ( /*#__PURE__*/React.createElement(Button, {
    className: "kg-style-config-add-property-button",
    type: "dashed",
    onClick: function onClick() {
      addPropertyItem();
    },
    disabled: !propertySelectorEnabled
  }, $i18n.get({
    id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.AddAttributes',
    dm: '增加属性'
  }))));
  var getPropertySelector = function getPropertySelector(itemType) {
    return /*#__PURE__*/React.createElement(React.Fragment, null, $i18n.get({
      id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.AttributeCondition',
      dm: '属性条件'
    }), /*#__PURE__*/React.createElement("span", {
      className: "kg-pattern-match-tip"
    }, $i18n.get({
      id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.Optional',
      dm: '可选'
    })), /*#__PURE__*/React.createElement("br", null), propertySelectorEnabled ? propertySelector : ( /*#__PURE__*/React.createElement(Tooltip, {
      title: type === 'edge' && (relatedEdgeTypes === null || relatedEdgeTypes === void 0 ? void 0 : relatedEdgeTypes.length) && selectedEdgeType || itemType === 'node' && (nodeTypes === null || nodeTypes === void 0 ? void 0 : nodeTypes.length) && selectedNodeType ? '' : "\u8BF7\u5148\u9009\u62E9".concat(itemType === 'node' ? '节点' : '边', "\u7C7B\u578B")
    }, propertySelector)));
  };
  var getEndTypeSelector = function getEndTypeSelector(endType) {
    var _a;
    return /*#__PURE__*/React.createElement(React.Fragment, null, endType === 'source' ? $i18n.get({
      id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.StartingPoint',
      dm: '起点'
    }) : $i18n.get({
      id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.EndPoint',
      dm: '终点'
    }), (itemData === null || itemData === void 0 ? void 0 : itemData["".concat(endType, "NodeType")]) ? ( /*#__PURE__*/React.createElement("span", null, ' ', ":", ' ', ((_a = nodeTypes.find(function (nodeType) {
      return nodeType.key === (itemData === null || itemData === void 0 ? void 0 : itemData["".concat(endType, "NodeType")]);
    })) === null || _a === void 0 ? void 0 : _a.content) || (itemData === null || itemData === void 0 ? void 0 : itemData["".concat(endType, "NodeType")]), ' ', /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("br", null))) : ( /*#__PURE__*/React.createElement(Form.Item, {
      rules: [{
        required: true,
        message: $i18n.get({
          id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.CannotBeEmpty',
          dm: '不可为空'
        })
      }],
      name: "edge.".concat(endType, "NodeType"),
      key: "edge.".concat(endType, "NodeType")
    }, /*#__PURE__*/React.createElement(Select, {
      showSearch: true,
      placeholder: $i18n.get({
        id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.PleaseSelect',
        dm: '请选择'
      }),
      style: {
        width: 316,
        marginTop: 8
      },
      onSelect: function onSelect(key) {
        return onSelectNodeType(key, endType);
      },
      dropdownMatchSelectWidth: false
    }, nodeTypes.map(function (nodeType) {
      return /*#__PURE__*/React.createElement(Option, {
        value: nodeType.key,
        key: nodeType.key
      }, nodeType.content);
    })))));
  };
  var edgeEditor = /*#__PURE__*/React.createElement(Form, {
    form: form,
    name: "edge"
  }, getEndTypeSelector('source'), getEndTypeSelector('target'), $i18n.get({
    id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.EdgeType',
    dm: '边类型'
  }), /*#__PURE__*/React.createElement("br", null), edgeSelectorEnabled ? edgeSelector : ( /*#__PURE__*/React.createElement(Tooltip, {
    title: !relatedEdgeTypes ? $i18n.get({
      id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.SelectTheStartAndEnd',
      dm: '请先选择起点与终点的类型'
    }) : $i18n.get({
      id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.TheEdgeTypeDoesNot',
      dm: '起点类型与终点类型之间不存在边类型'
    })
  }, edgeSelector)), getPropertySelector('edge'));
  var nodeEditor = /*#__PURE__*/React.createElement(Form, {
    form: form,
    name: "node"
  }, $i18n.get({
    id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.NodeType',
    dm: '节点类型'
  }), /*#__PURE__*/React.createElement(Form.Item, {
    rules: [{
      required: true,
      message: $i18n.get({
        id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.CannotBeEmpty',
        dm: '不可为空'
      })
    }],
    name: "node.nodeType",
    key: "node.nodeType"
  }, /*#__PURE__*/React.createElement(Select, {
    showSearch: true,
    placeholder: $i18n.get({
      id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.PleaseSelect',
      dm: '请选择'
    }),
    style: {
      width: 316,
      marginTop: 8
    },
    onSelect: function onSelect(key) {
      return onSelectNodeType(key, 'node');
    },
    dropdownMatchSelectWidth: false,
    defaultValue: itemData === null || itemData === void 0 ? void 0 : itemData.nodeType
  }, nodeTypes.map(function (nodeType) {
    return /*#__PURE__*/React.createElement(Option, {
      value: nodeType.key,
      key: nodeType.key
    }, nodeType.content);
  }))), getPropertySelector('node'));
  var drawerContent = type === 'edge' ? edgeEditor : nodeEditor;
  var drawerTitle = type === 'edge' ? $i18n.get({
    id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.EditEdge',
    dm: '编辑边'
  }) : $i18n.get({
    id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.EditPoint',
    dm: '编辑点'
  });
  if (!itemData) {
    drawerContent = /*#__PURE__*/React.createElement(React.Fragment, null);
    drawerTitle = '';
  }
  var confirmDisabled = type === 'edge' && !selectedEdgeType && !(itemData === null || itemData === void 0 ? void 0 : itemData.edgeType);
  return /*#__PURE__*/React.createElement(Drawer, {
    title: drawerTitle,
    visible: visible,
    width: 364,
    closable: true,
    onClose: cancelEdit,
    mask: false,
    style: {
      textAlign: 'left'
    },
    footerStyle: {
      textAlign: 'right'
    },
    getContainer: container || false,
    footer: /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Button, {
      onClick: cancelEdit
    }, $i18n.get({
      id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.Cancel',
      dm: '取消'
    })), /*#__PURE__*/React.createElement(Tooltip, {
      title: confirmDisabled ? $i18n.get({
        id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.TheRelationshipTypeCannotBe',
        dm: '关系类型不可为空'
      }) : '',
      placement: "topRight"
    }, /*#__PURE__*/React.createElement(Button, {
      type: "primary",
      style: {
        marginLeft: '8px'
      },
      onClick: confirmEdit,
      disabled: confirmDisabled
    }, $i18n.get({
      id: 'gi-assets-algorithm.src.PatternMatch.editDrawer.Ok',
      dm: '确定'
    }))))
  }, drawerContent);
};
export default EditDrawer;