"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _i18n = _interopRequireDefault(require("../i18n"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
var info = {
  id: 'InfoDetection',
  name: _i18n.default.get({
    id: 'gi-assets-algorithm.src.InfoDetection.info.InformationDetection',
    dm: '信息检测'
  }),
  desc: _i18n.default.get({
    id: 'gi-assets-algorithm.src.InfoDetection.info.DetectIsolatedPointsRingsEtc',
    dm: '检测画布中孤立点、环等'
  }),
  icon: 'icon-infomation',
  cover: 'http://xxxx.jpg',
  category: 'algorithm-analysis',
  type: 'GIAC_CONTENT',
  docs: 'https://www.yuque.com/antv/gi/id9rov6gyv7b0p7c'
};
var _default = exports.default = info;