"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.NodesSimilarityAlgorithm = void 0;
var _icons = require("@ant-design/icons");
var _algorithm = require("@antv/algorithm");
var _giCommonComponents = require("@antv/gi-common-components");
var _giSdk = require("@antv/gi-sdk");
var _antd = require("antd");
var _lodash = require("lodash");
var _react = _interopRequireWildcard(require("react"));
var _i18n = _interopRequireDefault(require("../i18n"));
require("./index.less");
var _resultTable = _interopRequireDefault(require("./resultTable"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == _typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
// @ts-nocheck

var NodesSimilarityAlgorithm;
(function (NodesSimilarityAlgorithm) {
  NodesSimilarityAlgorithm["nodesCosineSimilarity"] = "nodes-cosine-similarity";
})(NodesSimilarityAlgorithm || (exports.NodesSimilarityAlgorithm = NodesSimilarityAlgorithm = {}));
var CommunityDiscovery = function CommunityDiscovery(props) {
  var controlledValues = props.controlledValues,
    _props$style = props.style,
    style = _props$style === void 0 ? {} : _props$style,
    onOpen = props.onOpen,
    nodeSelectionMode = props.nodeSelectionMode,
    nodeLabel = props.nodeLabel,
    labelFormat = props.labelFormat,
    filter = props.filter;
  var _useContext = (0, _giSdk.useContext)(),
    data = _useContext.data,
    graph = _useContext.graph,
    updateHistory = _useContext.updateHistory;
  var _useState = (0, _react.useState)(NodesSimilarityAlgorithm.nodesCosineSimilarity),
    _useState2 = _slicedToArray(_useState, 2),
    communityAlgo = _useState2[0],
    setCommunityAlgo = _useState2[1];
  var _useState3 = (0, _react.useState)({
      nodes: [],
      edges: []
    }),
    _useState4 = _slicedToArray(_useState3, 2),
    initData = _useState4[0],
    setInitData = _useState4[1];
  var _useState5 = (0, _react.useState)(NodesSimilarityAlgorithm.nodesCosineSimilarity),
    _useState6 = _slicedToArray(_useState5, 2),
    similarityAlgo = _useState6[0],
    setSimilarityAlgo = _useState6[1];
  var _useState7 = (0, _react.useState)({
      similarityRes: [],
      similarNodes: []
    }),
    _useState8 = _slicedToArray(_useState7, 2),
    resData = _useState8[0],
    setResData = _useState8[1];
  var _useState9 = (0, _react.useState)(false),
    _useState10 = _slicedToArray(_useState9, 2),
    hasAnalysis = _useState10[0],
    setHasAnalysis = _useState10[1];
  var _useState11 = (0, _react.useState)(null),
    _useState12 = _slicedToArray(_useState11, 2),
    seedNodeId = _useState12[0],
    setSeedNodeId = _useState12[1];
  var _useState13 = (0, _react.useState)(false),
    _useState14 = _slicedToArray(_useState13, 2),
    topReset = _useState14[0],
    setTopReset = _useState14[1];
  var _Form$useForm = _antd.Form.useForm(),
    _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
    form = _Form$useForm2[0];
  (0, _react.useEffect)(function () {
    setInitData({
      //@ts-ignore
      nodes: (0, _lodash.cloneDeep)(graph.getNodes()).map(function (node) {
        return node.getModel();
      }),
      //@ts-ignore
      edges: (0, _lodash.cloneDeep)(graph.getEdges()).map(function (edge) {
        var model = edge.getModel();
        return Object.assign(Object.assign({}, model), {
          //@ts-ignore
          id: model.id || model.data.id
        });
      })
    });
  }, [data]);
  /**
   * 受控参数变化，自动进行分析
   * e.g. ChatGPT，历史记录模版等
   */
  (0, _react.useEffect)(function () {
    if (controlledValues) {
      var controlledSeed = controlledValues.seedNodeId,
        algorithm = controlledValues.algorithm;
      onOpen === null || onOpen === void 0 ? void 0 : onOpen();
      setSeedNodeId(controlledSeed);
      setSimilarityAlgo(algorithm);
      form === null || form === void 0 ? void 0 : form.setFieldValue('seed', controlledSeed);
      onAnalyse(algorithm);
    }
  }, [controlledValues]);
  /**
   * 更新到历史记录
   * @param success 是否成功
   * @param errorMsg 若失败，填写失败信息
   * @param value 查询语句
   */
  var handleUpdateHistory = function handleUpdateHistory(success, errorMsg) {
    updateHistory({
      componentId: 'NodesSimilarity',
      type: 'analyse',
      subType: _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodesSimilarity.Component.NodeSimilarity',
        dm: '节点相似性'
      }),
      statement: _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodesSimilarity.Component.AlgorithmSimilarityalgo',
        dm: '算法 {similarityAlgo}'
      }, {
        similarityAlgo: similarityAlgo
      }),
      success: success,
      errorMsg: errorMsg,
      params: {
        algorithm: similarityAlgo,
        seedNodeId: seedNodeId
      }
    });
  };
  var resetMapping = function resetMapping(mappedNodeIds, mappedEdgeIds) {
    graph.getNodes().forEach(function (node) {
      var _a, _b, _c;
      var id = node.get('id');
      var initModel = (_a = initData.nodes) === null || _a === void 0 ? void 0 : _a.find(function (initNode) {
        return initNode.id === id;
      });
      if (initModel && !(mappedNodeIds === null || mappedNodeIds === void 0 ? void 0 : mappedNodeIds.includes(id))) {
        graph.updateItem(node, {
          style: {
            keyshape: {
              size: (_c = (_b = initModel.style) === null || _b === void 0 ? void 0 : _b.keyshape) === null || _c === void 0 ? void 0 : _c.size
            }
          }
        });
      }
    });
    graph.getEdges().forEach(function (edge) {
      edge.refresh();
    });
  };
  var formatOriginData = function formatOriginData(_ref) {
    var _ref$nodes = _ref.nodes,
      nodes = _ref$nodes === void 0 ? [] : _ref$nodes,
      _ref$edges = _ref.edges,
      edges = _ref$edges === void 0 ? [] : _ref$edges;
    return {
      nodes: nodes.map(function (node) {
        var properties = Object.assign({}, node.data, node.data.properties);
        delete properties.id;
        return {
          id: node.id,
          label: node.label || node.data.label,
          properties: properties
        };
      }),
      edges: edges.map(function (edge) {
        return Object.assign(Object.assign({}, edge), {
          id: edge.id || edge.data.id
        });
      })
    };
  };
  var setNodeStyle = function setNodeStyle(nodes, similarityKey) {
    nodes.forEach(function (node) {
      graph.updateItem(node.id, {
        style: {
          keyshape: {
            size: Math.max(50 * node[similarityKey], 30)
          }
        }
      });
    });
    graph.getEdges().forEach(function (edge) {
      edge.refresh();
    });
  };
  var highlightNode = function highlightNode(nodeId) {
    var node = graph.findById(nodeId);
    if (node) {
      graph.setItemState(nodeId, 'selected', true);
      graph.updateItem(nodeId, {
        style: {
          keyshape: {
            size: 40
          }
        }
      });
      graph.getEdges().forEach(function (edge) {
        edge.refresh();
      });
    }
  };
  var onAnalyse = function onAnalyse(algorithm) {
    return __awaiter(void 0, void 0, void 0, /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      var formatData, _yield$form$validateF, seed, nodes, seedNode, _nodesCosineSimilarit, allCosineSimilarity, similarNodes;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            setHasAnalysis(true);
            formatData = formatOriginData(data);
            _context.next = 4;
            return form.validateFields();
          case 4:
            _yield$form$validateF = _context.sent;
            seed = _yield$form$validateF.seed;
            setSeedNodeId(seed);
            _context.t0 = algorithm || similarityAlgo;
            _context.next = _context.t0 === NodesSimilarityAlgorithm.nodesCosineSimilarity ? 10 : 25;
            break;
          case 10:
            if (!(!graph || graph.destroyed)) {
              _context.next = 13;
              break;
            }
            handleUpdateHistory(false, _i18n.default.get({
              id: 'gi-assets-algorithm.src.NodesSimilarity.Component.TheGraphInstanceDoesNot',
              dm: '图实例不存在'
            }));
            return _context.abrupt("return");
          case 13:
            nodes = (formatData === null || formatData === void 0 ? void 0 : formatData.nodes) || [];
            seedNode = nodes === null || nodes === void 0 ? void 0 : nodes.find(function (node) {
              return node.id === seed;
            });
            if (seedNode) {
              _context.next = 19;
              break;
            }
            _antd.message.info(_i18n.default.get({
              id: 'gi-assets-algorithm.src.NodesSimilarity.Component.TheSeedNodeDoesNot',
              dm: '种子节点不存在'
            }));
            handleUpdateHistory(false, _i18n.default.get({
              id: 'gi-assets-algorithm.src.NodesSimilarity.Component.TheSeedNodeSeednodeidDoes',
              dm: '种子节点{seedNodeId}不存在'
            }, {
              seedNodeId: seed
            }));
            return _context.abrupt("return");
          case 19:
            highlightNode(seed);
            // @ts-ignore
            _nodesCosineSimilarit = (0, _algorithm.nodesCosineSimilarity)(nodes, seedNode, 'properties'), allCosineSimilarity = _nodesCosineSimilarit.allCosineSimilarity, similarNodes = _nodesCosineSimilarit.similarNodes;
            setResData({
              similarityRes: allCosineSimilarity,
              similarNodes: [seedNode].concat(_toConsumableArray(similarNodes))
            });
            setNodeStyle(similarNodes, 'cosineSimilarity');
            handleUpdateHistory(true);
            return _context.abrupt("break", 27);
          case 25:
            handleUpdateHistory(false, "\u7B97\u6CD5".concat(algorithm || similarityAlgo, "\u4E0D\u5B58\u5728"));
            return _context.abrupt("break", 27);
          case 27:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
  };
  var renderResult = function renderResult() {
    if (!hasAnalysis) {
      return;
    }
    var _ref2 = resData || {},
      similarityRes = _ref2.similarityRes,
      similarNodes = _ref2.similarNodes;
    if (!(similarityRes === null || similarityRes === void 0 ? void 0 : similarityRes.length)) {
      return /*#__PURE__*/_react.default.createElement(_antd.Empty, {
        image: _antd.Empty.PRESENTED_IMAGE_SIMPLE,
        description: _i18n.default.get({
          id: 'gi-assets-algorithm.src.NodesSimilarity.Component.NoDataAvailable',
          dm: '暂无数据'
        })
      });
    }
    if (similarityAlgo === NodesSimilarityAlgorithm.nodesCosineSimilarity) {
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "nodes-similarity-result-wrapper"
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "nodes-similarity-title"
      }, _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodesSimilarity.Component.AnalysisResults',
        dm: '分析结果'
      })), /*#__PURE__*/_react.default.createElement(_resultTable.default, {
        similarNodes: similarNodes,
        topReset: topReset,
        similarityKey: "cosineSimilarity"
      }));
    }
  };
  var reset = function reset() {
    form.resetFields();
    resetMapping([], []);
    setResData({
      similarityRes: [],
      similarNodes: []
    });
    setCommunityAlgo(NodesSimilarityAlgorithm.nodesCosineSimilarity);
    setTopReset(true);
  };
  return /*#__PURE__*/_react.default.createElement("div", {
    style: Object.assign({}, style)
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "nodes-similarity-wrapper"
  }, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_antd.Form, {
    form: form,
    layout: 'vertical'
  }, /*#__PURE__*/_react.default.createElement(_giCommonComponents.NodeSelectionWrap
  // @ts-ignore
  , {
    // @ts-ignore
    graph: graph,
    form: form,
    items: [{
      name: 'seed',
      label: _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodesSimilarity.Component.SeedNode',
        dm: '种子节点'
      })
    }],
    filter: filter,
    data: data.nodes,
    labelFormat: labelFormat,
    nodeLabel: nodeLabel,
    nodeSelectionMode: nodeSelectionMode
  }))), /*#__PURE__*/_react.default.createElement("div", {
    className: "nodes-similarity-operations"
  }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    type: "primary",
    style: {
      width: '100%',
      marginTop: '12px'
    },
    onClick: function onClick() {
      return onAnalyse();
    }
  }, _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodesSimilarity.Component.Analysis',
    dm: '分析'
  })), /*#__PURE__*/_react.default.createElement(_icons.ReloadOutlined, {
    onClick: reset
  })), renderResult()));
};
var _default = exports.default = /*#__PURE__*/(0, _react.memo)(CommunityDiscovery);