"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _algorithm = _interopRequireDefault(require("@antv/algorithm"));
var _giSdk = require("@antv/gi-sdk");
var _antd = require("antd");
var _react = _interopRequireDefault(require("react"));
var _useImmer3 = require("use-immer");
require("./index.less");
var _PatternGraph = _interopRequireDefault(require("./PatternGraph"));
var _i18n = _interopRequireDefault(require("../i18n"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == _typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var GADDI = _algorithm.default.GADDI;
var Panel = _antd.Collapse.Panel;
var simplyDeepClone = function simplyDeepClone(obj) {
  return JSON.parse(JSON.stringify(obj));
};
var getKeys = function getKeys(pattern, type) {
  try {
    var item = pattern[type];
    return Object.keys(item[0].data);
  } catch (error) {
    return ['unkown'];
  }
};
var PATTERNS = [{
  id: 'pattern-0',
  name: _i18n.default.get({
    id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.TelecomFraudRiskModel',
    dm: '电信诈骗风险模式0'
  }),
  pattern: {
    nodes: [{
      id: 'p1',
      cluster: 'unkown'
    }, {
      id: 'p2',
      cluster: 'unkown'
    }, {
      id: 'p3',
      cluster: 'unkown'
    }],
    edges: [{
      source: 'p1',
      target: 'p2',
      cluster: 'transfer',
      label: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.Transfer',
        dm: '转账'
      })
    }, {
      source: 'p2',
      target: 'p1',
      cluster: 'transfer',
      label: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.Transfer',
        dm: '转账'
      })
    }, {
      source: 'p1',
      target: 'p3',
      cluster: 'transfer',
      label: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.Transfer',
        dm: '转账'
      })
    }, {
      source: 'p2',
      target: 'p3',
      cluster: 'transfer',
      label: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.Transfer',
        dm: '转账'
      })
    }]
  }
}, {
  id: 'pattern-1',
  name: _i18n.default.get({
    id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.TelecomFraudRiskModel.1',
    dm: '电信诈骗风险模式一'
  }),
  pattern: {
    nodes: [{
      id: 'p1',
      dataType: 'unkown',
      label: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.Account',
        dm: '账户'
      })
    }, {
      id: 'p2',
      dataType: 'account',
      label: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.Account',
        dm: '账户'
      })
    }, {
      id: 'p3',
      dataType: 'account',
      label: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.Account',
        dm: '账户'
      })
    }],
    edges: [{
      source: 'p1',
      target: 'p2',
      dataType: 'transfer',
      label: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.Transfer',
        dm: '转账'
      })
    }, {
      source: 'p2',
      target: 'p1',
      dataType: 'transfer',
      label: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.Transfer',
        dm: '转账'
      })
    }, {
      source: 'p1',
      target: 'p3',
      dataType: 'transfer',
      label: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.Transfer',
        dm: '转账'
      })
    }, {
      source: 'p2',
      target: 'p3',
      dataType: 'transfer',
      label: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.Transfer',
        dm: '转账'
      })
    }]
  }
}];
var PatternMatch = function PatternMatch(_ref) {
  var visible = _ref.visible,
    onClose = _ref.onClose,
    serviceId = _ref.serviceId,
    style = _ref.style;
  var _useImmer = (0, _useImmer3.useImmer)({
      mode: 'new',
      pattern: {
        nodes: [],
        edges: []
      },
      nodeKey: 'dataType',
      edgeKey: 'dataType'
    }),
    _useImmer2 = _slicedToArray(_useImmer, 2),
    state = _useImmer2[0],
    updateState = _useImmer2[1];
  var _useContext = (0, _giSdk.useContext)(),
    graph = _useContext.graph,
    services = _useContext.services,
    data = _useContext.data,
    updateContext = _useContext.updateContext;
  var pattern = state.pattern;
  var _Form$useForm = _antd.Form.useForm(),
    _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
    form = _Form$useForm2[0];
  _react.default.useEffect(function () {
    var onNodeSelectChange = function onNodeSelectChange(e) {
      try {
        var nodes = e.selectedItems.nodes.map(function (node) {
          var model = node.get('model');
          return {
            id: model.id,
            data: model.data,
            dataType: model.dataType
          };
        }) || [];
        var edges = e.selectedItems.edges.map(function (edge) {
          var model = edge.get('model');
          return {
            source: model.source,
            target: model.target,
            data: model.data,
            dataType: model.dataType
          };
        }) || [];
        if (nodes.length === 0 || edges.length === 0) {
          return;
        }
        console.log({
          nodes: nodes,
          edges: edges
        });
        updateState(function (draft) {
          draft.pattern = {
            nodes: nodes,
            edges: edges
          };
        });
      } catch (error) {
        console.log(error);
      }
    };
    //@ts-ignore
    graph.on('nodeselectchange', onNodeSelectChange);
    return function () {
      graph.off('nodeselectchange', onNodeSelectChange);
    };
  }, [graph, updateState]);
  var handleClick = function handleClick() {
    return __awaiter(void 0, void 0, void 0, /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      var isVaild, _data, clonePattern, matches;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            //@ts-ignore
            isVaild = pattern.nodes && pattern.nodes.length !== 0 && pattern.edges && pattern.edges.length !== 0;
            if (isVaild) {
              _context.next = 4;
              break;
            }
            return _context.abrupt("return");
          case 4:
            //@ts-ignore
            _data = simplyDeepClone(GiState.data);
            clonePattern = simplyDeepClone(pattern);
            if (state.nodeKey == 'unkown') {
              _data.nodes.forEach(function (n) {
                n.unkown = 'unkown';
              });
              //@ts-ignore
              clonePattern.nodes.forEach(function (n) {
                n.unkown = 'unkown';
              });
            }
            if (state.edgeKey == 'unkown') {
              _data.edges.forEach(function (e) {
                e.unkown = 'unkown';
              });
              //@ts-ignore
              clonePattern.edges.forEach(function (e) {
                e.unkown = 'unkown';
              });
            }
            matches = GADDI(_data, clonePattern, true,
            //@ts-ignore
            undefined, undefined, state.nodeKey, state.edgeKey);
            console.log('matches', matches);
            matches.forEach(function (match, i) {
              graph.createHull({
                id: "match-".concat(i),
                members: match.nodes.map(function (node) {
                  return node.id;
                }),
                style: {
                  fill: '#f00',
                  stroke: '#f00'
                }
              });
            });
            _context.next = 16;
            break;
          case 13:
            _context.prev = 13;
            _context.t0 = _context["catch"](0);
            console.log(_context.t0);
          case 16:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[0, 13]]);
    }));
  };
  var clear = function clear() {
    form.resetFields();
    graph.removeHulls();
  };
  var PatternOptions = [{
    label: _i18n.default.get({
      id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.Create',
      dm: '新建'
    }),
    value: 'new',
    disabled: false
  }, {
    label: _i18n.default.get({
      id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.SchemaLibrary',
      dm: '模式库'
    }),
    value: 'template',
    disabled: true
  }];
  var NODE_KEYS = ['type', 'dataType']; //getKeys(pattern, 'node');
  var EDGE_KEYS = ['edgeType', 'dataType']; //getKeys(pattern, 'edge');
  if (visible) {
    return /*#__PURE__*/_react.default.createElement("div", {
      style: Object.assign({
        position: 'absolute',
        background: '#fff',
        width: '420px',
        padding: '12px',
        boxShadow: '0 2px 4px 0 rgb(0 0 0 / 10%)'
      }, style)
    }, /*#__PURE__*/_react.default.createElement(_antd.Form, {
      initialValues: state,
      form: form
    }, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("h3", null, _i18n.default.get({
      id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.PatternMatching',
      dm: '模式匹配'
    })), ' ', /*#__PURE__*/_react.default.createElement(_antd.Button, {
      onClick: clear
    }, _i18n.default.get({
      id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.Reproduction',
      dm: '重制'
    }))), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
      label: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.ModeSelection',
        dm: '模式选择'
      }),
      name: "mode",
      rules: [{
        required: true,
        message: _i18n.default.get({
          id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.SelectAMode',
          dm: '请选择模式'
        })
      }]
    }, /*#__PURE__*/_react.default.createElement(_antd.Radio.Group, {
      options: PatternOptions,
      onChange: function onChange(e) {
        updateState(function (draft) {
          draft.mode = e.target.value;
        });
      },
      value: state.mode
    })), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
      label: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.SelectTheClusterFieldOf',
        dm: '选择节点的聚类字段'
      }),
      name: "nodeKey"
    }, /*#__PURE__*/_react.default.createElement(_antd.Select, {
      allowClear: true,
      style: {
        width: '100%'
      },
      placeholder: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.SelectAFieldDefaultValue',
        dm: '请选择字段，默认为unkown'
      }),
      value: state.nodeKey,
      onChange: function onChange(val) {
        updateState(function (draft) {
          draft.nodeKey = val;
        });
      }
    }, NODE_KEYS.map(function (key) {
      return /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
        key: key,
        value: key
      }, key);
    }))), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
      label: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.SelectTheClusterFieldOf.1',
        dm: '选择边的聚类字段'
      }),
      name: "nodeKey"
    }, /*#__PURE__*/_react.default.createElement(_antd.Select, {
      allowClear: true,
      style: {
        width: '100%'
      },
      placeholder: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.SelectAFieldDefaultValue',
        dm: '请选择字段，默认为unkown'
      }),
      value: state.edgeKey,
      onChange: function onChange(val) {
        updateState(function (draft) {
          draft.edgeKey = val;
        });
      }
    }, EDGE_KEYS.map(function (key) {
      return /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
        key: key,
        value: key
      }, key);
    }))), /*#__PURE__*/_react.default.createElement(_PatternGraph.default, {
      pattern: pattern
    }), /*#__PURE__*/_react.default.createElement(_antd.Button, {
      type: "primary",
      style: {
        width: '100%',
        marginTop: '12px'
      },
      onClick: handleClick
    }, _i18n.default.get({
      id: 'gi-assets-algorithm.src.PatternMatchSimple.Component.StartMatching',
      dm: '开始匹配'
    }))));
  }
  return null;
};
var _default = exports.default = PatternMatch;