"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.components = void 0;
var _CommunityDetection = _interopRequireDefault(require("./CommunityDetection"));
var _InfoDetection = _interopRequireDefault(require("./InfoDetection"));
var _NodeImportance = _interopRequireDefault(require("./NodeImportance"));
var _NodesClustering = _interopRequireDefault(require("./NodesClustering"));
var _NodesSimilarity = _interopRequireDefault(require("./NodesSimilarity"));
var _PatternMatch = _interopRequireDefault(require("./PatternMatch"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
var components = exports.components = {
  NodesClustering: _NodesClustering.default,
  NodesSimilarity: _NodesSimilarity.default,
  CommunityDetection: _CommunityDetection.default,
  NodeImportance: _NodeImportance.default,
  PatternMatch: _PatternMatch.default,
  InfoDetection: _InfoDetection.default
};