"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _i18n = _interopRequireDefault(require("../i18n"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
/**   index.md 中解析得到默认值，也可用户手动修改 */
var info = {
  id: 'NodeImportance',
  name: _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.info.NodeImportance',
    dm: '节点重要性'
  }),
  category: 'algorithm-analysis',
  type: 'GIAC_CONTENT',
  desc: _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodeImportance.info.ThroughPagerankDegreeCentralityAttributes',
    dm: '通过 PageRank、度中心性、属性等'
  }),
  cover: 'http://xxxx.jpg',
  icon: 'icon-rules',
  docs: 'https://www.yuque.com/antv/gi/synavummamac5yya'
};
var _default = exports.default = info;