"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _giSdk = require("@antv/gi-sdk");
var _antd = require("antd");
var _react = _interopRequireWildcard(require("react"));
var _registerMeta = require("./registerMeta");
var _i18n = _interopRequireDefault(require("../i18n"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _objectDestructuringEmpty(t) { if (null == t) throw new TypeError("Cannot destructure " + t); } /**
 * author:shiwu.wyy@antgroup.com
 */
var Option = _antd.Select.Option;
var PropertyContent = function PropertyContent(_ref) {
  var type = _ref.type,
    visible = _ref.visible,
    form = _ref.form,
    properties = _ref.properties;
  var _a;
  _objectDestructuringEmpty((0, _giSdk.useContext)());
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    loading = _useState2[0],
    setLoading = _useState2[1];
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "algo-body algo-body-property"
  }, /*#__PURE__*/_react.default.createElement("span", {
    style: {
      marginLeft: 8
    }
  }, /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    rules: [{
      required: visible,
      message: _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodeImportance.propertyContent.CannotBeEmpty',
        dm: '不可为空'
      })
    }],
    name: "".concat(type, "-property.property"),
    key: "".concat(type, "-property.property"),
    label: _i18n.default.get({
      id: 'gi-assets-algorithm.src.NodeImportance.propertyContent.Properties',
      dm: '属性'
    })
  }, /*#__PURE__*/_react.default.createElement(_antd.Select, {
    placeholder: _i18n.default.get({
      id: 'gi-assets-algorithm.src.NodeImportance.propertyContent.PleaseSelect',
      dm: '请选择'
    }),
    dropdownMatchSelectWidth: false,
    notFoundContent: loading ? ( /*#__PURE__*/_react.default.createElement(_antd.Spin, null)) : _i18n.default.get({
      id: 'gi-assets-algorithm.src.NodeImportance.propertyContent.NoData',
      dm: '无数据'
    })
  }, (_a = properties === null || properties === void 0 ? void 0 : properties.map) === null || _a === void 0 ? void 0 : _a.call(properties, function (property) {
    return /*#__PURE__*/_react.default.createElement(Option, {
      value: property,
      key: property
    }, property);
  })))), type === 'edge' && ( /*#__PURE__*/_react.default.createElement("span", {
    style: {
      marginLeft: 8
    }
  }, /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    rules: [{
      required: visible,
      message: _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodeImportance.propertyContent.CannotBeEmpty',
        dm: '不可为空'
      })
    }],
    name: "".concat(type, "-property.calcway"),
    key: "".concat(type, "-property.calcway"),
    label: _i18n.default.get({
      id: 'gi-assets-algorithm.src.NodeImportance.propertyContent.CalculationMethod',
      dm: '计算方式'
    })
  }, /*#__PURE__*/_react.default.createElement(_antd.Select, {
    placeholder: _i18n.default.get({
      id: 'gi-assets-algorithm.src.NodeImportance.propertyContent.PleaseSelect',
      dm: '请选择'
    }),
    dropdownMatchSelectWidth: false,
    dropdownClassName: "calc",
    //@ts-ignore
    getPopupContainer: function getPopupContainer() {
      return document.getElementById('select-drop-down-area');
    }
  }, /*#__PURE__*/_react.default.createElement(Option, {
    value: 'sort',
    key: 'sort'
  }, _registerMeta.locale['sort'], /*#__PURE__*/_react.default.createElement("br", null), /*#__PURE__*/_react.default.createElement("p", {
    className: "calc-tip"
  }, _registerMeta.locale['sort-tip'])), /*#__PURE__*/_react.default.createElement(Option, {
    value: 'count',
    key: 'count'
  }, _registerMeta.locale['count'], /*#__PURE__*/_react.default.createElement("br", null), /*#__PURE__*/_react.default.createElement("p", {
    className: "calc-tip"
  }, _registerMeta.locale['count-tip'])))))), /*#__PURE__*/_react.default.createElement("span", {
    style: {
      marginLeft: 8
    }
  }, /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    rules: [{
      required: visible,
      message: _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodeImportance.propertyContent.CannotBeEmpty',
        dm: '不可为空'
      })
    }],
    name: "".concat(type, "-property.mappingway"),
    key: "".concat(type, "-property.mappingway"),
    initialValue: _registerMeta.MappingWay.Positive,
    label: _i18n.default.get({
      id: 'gi-assets-algorithm.src.NodeImportance.propertyContent.MappingMethod',
      dm: '映射方式'
    })
  }, /*#__PURE__*/_react.default.createElement(_antd.Select, {
    placeholder: _i18n.default.get({
      id: 'gi-assets-algorithm.src.NodeImportance.propertyContent.PleaseSelect',
      dm: '请选择'
    }),
    dropdownMatchSelectWidth: false,
    dropdownClassName: "mapping",
    //@ts-ignore
    getPopupContainer: function getPopupContainer() {
      return document.getElementById('select-drop-down-area');
    }
  }, /*#__PURE__*/_react.default.createElement(Option, {
    value: _registerMeta.MappingWay.Positive,
    key: _registerMeta.MappingWay.Positive
  }, _registerMeta.locale['positive-correlation'], /*#__PURE__*/_react.default.createElement("br", null), /*#__PURE__*/_react.default.createElement("p", {
    className: "mapping-tip"
  }, _registerMeta.locale['positive-tip'])), /*#__PURE__*/_react.default.createElement(Option, {
    value: _registerMeta.MappingWay.Negative,
    key: _registerMeta.MappingWay.Negative
  }, _registerMeta.locale['negative-correlation'], /*#__PURE__*/_react.default.createElement("br", null), /*#__PURE__*/_react.default.createElement("p", {
    className: "mapping-tip"
  }, _registerMeta.locale['negative-tip']))))));
};
var _default = exports.default = PropertyContent;