"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _giSdk = require("@antv/gi-sdk");
var _antd = require("antd");
var _react = _interopRequireWildcard(require("react"));
var _registerMeta = require("./registerMeta");
var _i18n = _interopRequireDefault(require("../i18n"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var ResultTable = function ResultTable(_ref) {
  var data = _ref.data,
    currentAlgo = _ref.currentAlgo,
    form = _ref.form,
    reAnalyse = _ref.reAnalyse,
    nodeProperties = _ref.nodeProperties;
  var _useContext = (0, _giSdk.useContext)(),
    graph = _useContext.graph;
  var formValues = form.getFieldsValue();
  var edgeType = formValues['edge-property.edgeType'];
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    sortOrder = _useState2[0],
    setSortOrder = _useState2[1];
  var _useState3 = (0, _react.useState)('id'),
    _useState4 = _slicedToArray(_useState3, 2),
    propertyKey = _useState4[0],
    setPropertyKey = _useState4[1];
  (0, _react.useEffect)(function () {
    setSortOrder(false);
  }, [reAnalyse]);
  var getResultColumns = function getResultColumns() {
    var columns = [{
      title: _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodeImportance.resultTable.SerialNumber',
        dm: '序号'
      }),
      dataIndex: 'index',
      key: 'index',
      width: 60
    }, {
      title: (nodeProperties === null || nodeProperties === void 0 ? void 0 : nodeProperties.length) ? ( /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodeImportance.resultTable.Node',
        dm: '节点'
      }), /*#__PURE__*/_react.default.createElement(_antd.Select, {
        className: "result-table-property-select",
        size: "small",
        defaultValue: "id",
        options: nodeProperties.map(function (key) {
          return {
            label: key,
            value: key
          };
        }),
        dropdownMatchSelectWidth: false,
        onChange: setPropertyKey
      }))) : _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodeImportance.resultTable.Node',
        dm: '节点'
      }),
      dataIndex: 'name',
      key: 'name',
      textWrap: 'word-break',
      ellipsis: true
    }, {
      title: _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodeImportance.resultTable.Importance',
        dm: '重要性'
      }),
      dataIndex: 'value',
      key: 'value',
      textWrap: 'word-break',
      sortOrder: sortOrder,
      sorter: function sorter(a, b) {
        return a.value - b.value;
      }
    }];
    if (currentAlgo === 'edge-property' && data.calcWay === 'count') {
      //@ts-ignore
      columns.splice(2, 0, {
        title: _i18n.default.get({
          id: 'gi-assets-algorithm.src.NodeImportance.resultTable.AttributeName',
          dm: '属性名'
        }),
        dataIndex: 'values',
        key: 'values',
        textWrap: 'word-break'
      });
      columns[3].title = _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodeImportance.resultTable.CalculationMethod',
        dm: '计算方式'
      });
    }
    return columns;
  };
  var getResultTableData = function getResultTableData() {
    var nodes = _toConsumableArray(data.node.data);
    if (data.mappingWay === _registerMeta.MappingWay.Negative) {
      nodes.reverse();
    }
    return nodes.map(function (node, index) {
      var _a;
      return {
        key: node.id,
        index: index + 1,
        name: node.originProperties[propertyKey] || node.id,
        value: node.value,
        values: (_a = node.values) === null || _a === void 0 ? void 0 : _a.join('; ')
      };
    });
  };
  var clearActiveItems = function clearActiveItems() {
    var activateItems = graph.findAllByState('node', _registerMeta.ITEM_STATE.Active).concat(graph.findAllByState('edge', _registerMeta.ITEM_STATE.Active));
    activateItems.forEach(function (item) {
      graph.setItemState(item, _registerMeta.ITEM_STATE.Active, false);
    });
  };
  var onEnterTableRow = function onEnterTableRow(record) {
    var _a, _b;
    clearActiveItems();
    var item = graph.findById(record.key);
    if (!item) {
      return;
    }
    graph.setItemState(item, _registerMeta.ITEM_STATE.Active, true);
    // 若为关系属性重要性, 同时高亮该节点相关的被映射过的边
    if (currentAlgo === 'edge-property') {
      (_b = (_a = data.edge) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.forEach(function (edge) {
        var edgeItem = graph.findById(edge.id);
        if (!edgeItem) {
          return;
        }
        var edgeModel = edgeItem.getModel();
        //@ts-ignore
        if (edgeModel.data.label !== (edgeType === null || edgeType === void 0 ? void 0 : edgeType.split('_')[1])) {
          return;
        }
        if (edgeModel.source === record.key || edgeModel.target === record.id) {
          graph.setItemState(edgeItem, _registerMeta.ITEM_STATE.Active, true);
        }
      });
    }
  };
  var onTableChange = function onTableChange(pagination, filters, sorter, extra) {
    if (extra.action === 'sort') {
      setSortOrder(sorter.order || false);
    }
  };
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "result-wrapper"
  }, /*#__PURE__*/_react.default.createElement(_antd.Table, {
    dataSource: getResultTableData(),
    //@ts-ignore
    columns: getResultColumns(),
    size: "small",
    style: {
      marginTop: '16px'
    },
    showSorterTooltip: {
      title: _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodeImportance.resultTable.Sort',
        dm: '排序'
      })
    },
    onRow: function onRow(record) {
      return {
        onMouseEnter: function onMouseEnter() {
          return onEnterTableRow(record);
        },
        onMouseLeave: clearActiveItems
      };
    },
    onChange: onTableChange
  }));
};
var _default = exports.default = ResultTable;