"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _Component = _interopRequireDefault(require("./Component"));
var _registerMeta = _interopRequireDefault(require("./registerMeta"));
var _i18n = _interopRequireDefault(require("../i18n"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
/**   index.md 中解析得到默认值，也可用户手动修改 */
var info = {
  id: 'PatternMatch',
  name: _i18n.default.get({
    id: 'gi-assets-algorithm.src.PatternMatchSimple.PatternMatching',
    dm: '模式匹配'
  }),
  category: 'components',
  desc: _i18n.default.get({
    id: 'gi-assets-algorithm.src.PatternMatchSimple.PatternMatching',
    dm: '模式匹配'
  }),
  cover: 'http://xxxx.jpg',
  type: 'GI_CONTAINER_INDEX'
};
var _default = exports.default = {
  info: info,
  component: _Component.default,
  registerMeta: _registerMeta.default
};